<!DOCTYPE html>
<html lang="es">
  <head>
    <meta charset="utf-8">
    <title></title>
    <link rel="stylesheet" href="/css/bootstrap.min.css" crossorigin="anonymous">
  </head>
  <body>
    <div class="container">
      <h1> Usuarios </h1>
      <div class="form-group row">
        <button type="button" class="btn btn-success" onclick="" data-toggle="modal" data-target="#createModal">Crear Nuevo Usuario</button>
      </div>
      <table id="tblUsuarios" class="table table-hover">
        <thead class="thead-dark">
          <tr>
            <th scope="col" class='d-none'>ID</th>
            <th scope="col">Nombre</th>
            <th scope="col">Correo</th>
            <th scope="col">Fecha Creación</th>
            <th scope="col">Fecha Modificación</th>
            <th scope="col">Observaciones</th>
            <th scope="col">Estado</th>
            <th scope="col"></th>
            <th scope="col"></th>
          </tr>
        </thead>
        <tbody>
          <% for(var i=0; i < usuarios.length; i++) { %>
            <tr id-data = <%=usuarios[i]._id%> >
              <th scope="row" class='d-none'><%=usuarios[i]._id%></th>
              <th class='nombre' scope="row"><%=usuarios[i].nombre%></th>
              <td class='correo'><%=usuarios[i].correo%></td>
              <td class="center"><%=usuarios[i].fecha_creacion%></td>
              <td class="center"><%=usuarios[i].fecha_modificacion%></td>
              <td class='observacion'><%=usuarios[i].observacion%></td>
              <td class='estado'><%=usuarios[i].estado%></td>
              <td class="center"><button type="button" class="btn btn-primary btn-sm" onclick="setIdModal(this)" data-toggle="modal" data-target="#editModal">Editar</button></td>
              <td class="center"><button type="button" class="btn btn-secondary btn-sm" onclick="eliminar(this)">Eliminar</button></td>
            </tr>
          <% } %>
        </tbody>
      </table>


      <!-- Modal -->
      <div class="modal fade" id="editModal" tabindex="-1" role="dialog" aria-labelledby="editModalTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLongTitle">Edición Usuario</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <form>
              <div class="modal-body">
                  <input name="id" type="text" class="form-control d-none" id="inputId" placeholder="ID">
                  <div class="form-group row">
                    <label for="inputNombre" class="col-sm-2 col-form-label">Nombre</label>
                    <div class="col-sm-10">
                      <input name="nombre" type="text" class="form-control" id="inputNombre" placeholder="Nombre">
                    </div>
                  </div>
                  <div class="form-group row">
                    <label for="inputEmail" class="col-sm-2 col-form-label">Email</label>
                    <div class="col-sm-10">
                      <input name="correo" type="email" class="form-control" id="inputEmail" placeholder="Email">
                    </div>
                  </div>
                  <div class="form-group row">
                    <label for="inputObservaciones" class="col-sm-2 col-form-label">Observaciones</label>
                    <div class="col-sm-10">
                      <input name = 'observacion' type="text" class="form-control" id="inputObservaciones" placeholder="Observaciones">
                    </div>
                  </div>
                  <div class="form-group row">
                    <label for="inputEstado" class="col-sm-2 col-form-label">Estado</label>
                    <div class="col-sm-10">
                      <input name = 'estado' type="number" class="form-control" id="inputEstado" placeholder="Estado">
                    </div>
                  </div>
              </div>
              <div class="modal-footer">
                <button type="button"  onclick="actualizar()" class="btn btn-primary">Guardar Cambios</button>
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
              </div>
            </form>
          </div>
        </div>
      </div>

      <!-- Modal -->
      <div class="modal fade" id="createModal" tabindex="-1" role="dialog" aria-labelledby="createModalTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLongTitle">Creación Usuario</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <form>
              <div class="modal-body">
                  <!-- <input name="id" type="text" class="form-control d-none" id="inputId" placeholder="ID"> -->
                  <div class="form-group row">
                    <label for="inputCreateNombre" class="col-sm-2 col-form-label">Nombre</label>
                    <div class="col-sm-10">
                      <input name="nombre" type="text" class="form-control" id="inputCreateNombre" placeholder="Nombre">
                    </div>
                  </div>
                  <div class="form-group row">
                    <label for="inputCreateEmail" class="col-sm-2 col-form-label">Email</label>
                    <div class="col-sm-10">
                      <input name="correo" type="email" class="form-control" id="inputCreateEmail" placeholder="Email">
                    </div>
                  </div>
                  <div class="form-group row">
                    <label for="inputCreateObservaciones" class="col-sm-2 col-form-label">Observaciones</label>
                    <div class="col-sm-10">
                      <input name = 'observacion' type="text" class="form-control" id="inputCreateObservaciones" placeholder="Observaciones">
                    </div>
                  </div>
                  <div class="form-group row">
                    <label for="inputCreateEstado" class="col-sm-2 col-form-label">Estado</label>
                    <div class="col-sm-10">
                      <input name = 'estado' type="number" class="form-control" id="inputCreateEstado" placeholder="Estado">
                    </div>
                  </div>
              </div>
              <div class="modal-footer">
                <button type="button"  onclick="crear()" class="btn btn-primary">Crear</button>
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
              </div>
            </form>
          </div>
        </div>
      </div>

    </div>

  <script src="js/bootstrap/jquery-3.3.1.min.js"></script>
  <script src="js/bootstrap/popper.min.js"></script>
  <script src="js/bootstrap/bootstrap.min.js"></script>
  <script>
    function setIdModal(el){
      id = el.closest('tr').getAttribute('id-data');
      $('#inputId').val(id);
      // console.log($(el.closest('tr')).find('.nombre').html());
      $('#inputNombre').val($(el.closest('tr')).find('.nombre').html());
      $('#inputEmail').val($(el.closest('tr')).find('.correo').html());
      $('#inputObservaciones').val($(el.closest('tr')).find('.observacion').html());
      $('#inputEstado').val($(el.closest('tr')).find('.estado').html());
    }


    function crear(){
      id = $('#inputId').val();
      var r = confirm("Confirmar Acción");
      if (r == true) {
        var xhttp = new XMLHttpRequest();
        xhttp.open("POST", "http://localhost:4500/usuario/"+id, true);
        xhttp.setRequestHeader("Content-type", "application/json");
        xhttp.send(JSON.stringify([{
                                    nombre: $('#inputCreateNombre').val(),
                                    correo: $('#inputCreateEmail').val(),
                                    observacion: $('#inputCreateObservaciones').val(),
                                    estado: $('#inputCreateEstado').val(),
                                  }]));

      }

      $('#tblUsuarios').load('http://localhost:4500/' +  ' #tblUsuarios', function( response, status, xhr ) {
        if ( status == "error" ) {
          var msg = "Sorry but there was an error: ";
          $( "#error" ).html( msg + xhr.status + " " + xhr.statusText );
        }
      });
    }

    function actualizar(){
      id = $('#inputId').val();
      var r = confirm("Confirmar Acción");
      if (r == true) {
        var xhttp = new XMLHttpRequest();
        xhttp.open("PUT", "http://localhost:4500/usuario/"+id, true);
        xhttp.setRequestHeader("Content-type", "application/json");
        xhttp.send(JSON.stringify([{
                                    nombre: $('#inputNombre').val(),
                                    correo: $('#inputEmail').val(),
                                    observacion: $('#inputObservaciones').val(),
                                    estado: $('#inputEstado').val(),
                                  }]));

      }

      $('#tblUsuarios').load('http://localhost:4500/' +  ' #tblUsuarios', function( response, status, xhr ) {
        if ( status == "error" ) {
          var msg = "Sorry but there was an error: ";
          $( "#error" ).html( msg + xhr.status + " " + xhr.statusText );
        }
      });
    }
    function eliminar(el){
      idDelete = el.closest('tr').getAttribute('id-data');
      var r = confirm("Confirmar Eliminación");
      if (r == true) {
        var xhttp = new XMLHttpRequest();
        xhttp.open("DELETE", "http://localhost:4500/usuario/"+idDelete, true);
        xhttp.setRequestHeader("Content-type", "application/json");
        xhttp.send();
        $('#tblUsuarios').load('http://localhost:4500/' +  ' #tblUsuarios', function( response, status, xhr ) {
          if ( status == "error" ) {
            var msg = "Sorry but there was an error: ";
            $( "#error" ).html( msg + xhr.status + " " + xhr.statusText );
          }
        });
        // var response = JSON.parse(xhttp.responseText);
      }
    }
  </script>
  </body>
</html>
